> For the complete documentation index, see [llms.txt](https://docs.hollaex.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hollaex.com/plugins/develop-plugins/development-walkthrough-hello-plugin.md).

# Development Walkthrough: Hello-Plugin

## The Goal

Over the next few pages, each of the page's concepts will be illustrated with a simple example plugin *hello-plugin.*&#x20;

What the *hello-plugin* plugin will allow is calling the endpoint `GET /plugins/hello-plugin/info` and receive the following response:&#x20;

```javascript
{
    public_message: 'Hello Plugin!',
    private_message: 'Hello Plugin...',
    library_message: 'Hello Plugin NPM',
    moment_timestamp: <ISO_STRING>
    exchange_info: {...}
}
```

The elements of this output come from the following sources:

* `public_message`: A value set in `public_meta`.
* `private_message`: A value set in `meta`
* `library_message`: The string produced by our third-party npm library.
* `moment_timestamp`: Date ISO string produced by a default library (`moment`).
* `exchange_info`: The exchange's basic information.

We will also be adding a new page to our exchange `web_view` that displays our custom client-side interface for *hello-plugin*.

In the next sections, we go through all the components in the plugin and gradually develop each component for *hello-plugin* step by step.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.hollaex.com/plugins/develop-plugins/development-walkthrough-hello-plugin.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
